//------------------------------------------------------------------------------
#include "mt_obj.h"
//------------------------------------------------------------------------------
mt_obj::mt_obj(void)
{
#ifdef IS_LINUX
    pthread_mutexattr_t mutexattr;
    pthread_mutexattr_settype(&mutexattr, PTHREAD_MUTEX_RECURSIVE_NP);
    pthread_mutex_init(&mutex, &mutexattr);
    pthread_mutexattr_destroy(&mutexattr);
#else
    InitializeCriticalSection(&cs);
#endif
}
//------------------------------------------------------------------------------
mt_obj::~mt_obj(void)
{
#ifdef IS_LINUX
    pthread_mutex_destroy(&mutex);
#else
    DeleteCriticalSection(&cs);
#endif
}
//------------------------------------------------------------------------------
void mt_obj::lock(void)
{
#ifdef IS_LINUX
    pthread_mutex_lock(&mutex);
#else
    EnterCriticalSection(&cs);
#endif
}
//------------------------------------------------------------------------------
void mt_obj::unlock(void)
{
#ifdef IS_LINUX
    pthread_mutex_unlock(&mutex);
#else
    LeaveCriticalSection(&cs);
#endif
}
