//------------------------------------------------------------------------------
#ifndef platform_h
#define platform_h
//------------------------------------------------------------------------------
//#define IS_LINUX

#ifdef IS_LINUX

#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <fcntl.h>
#include <unistd.h>
#include <pthread.h>

#define SOCKET int
#define INVALID_SOCKET -1
#define SOCKET_ERROR -1
#define closesocket close
#define SOCKADDR_IN sockaddr_in
#define SOCKADDR sockaddr
#define SD_BOTH 2

#else

#include <winsock2.h>
#include <WS2tcpip.h>
#include <windows.h>

#ifndef S_IFDIR
#define S_IFDIR  0x4000  /* directory */
#endif

#ifndef S_ISDIR
#define S_ISDIR(m)  ((m) & S_IFDIR)
#endif

#endif
//------------------------------------------------------------------------------
#ifdef IS_LINUX

void Sleep(unsigned long ms);

#endif

bool enable_nonblocking_mode(SOCKET s, const bool value);
//------------------------------------------------------------------------------
#endif //platform_h
