//------------------------------------------------------------------------------
#include <winsock>
#include <stdio.h>
#include <string>
//------------------------------------------------------------------------------
int get_addr(char *host_name)
{
    int res = -1;

    HOSTENT *phe = gethostbyname(host_name);
    if (phe)
        for (int i = 0; i < 4; i++)
            ((BYTE *)&res)[i] = phe->h_addr_list[0][i];

    return res;
}
//------------------------------------------------------------------------------
int main(int argc, char* argv[])
{
    WSADATA wsa_data;
    if (WSAStartup(0x101, &wsa_data))
    {
        printf("WSAStartup error (%i)\n", WSAGetLastError());
        system("pause");
        return -1;
    }

    if (wsa_data.wVersion != 0x101)
    {
        printf("Bad WSA version (%i)\n", wsa_data.wVersion);
        system("pause");
        return -1;
    }

    SOCKET s = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);
    if (s == INVALID_SOCKET)
    {
        printf("socket error (%i)\n", WSAGetLastError());
        system("pause");
        return -1;
    }

    int use_host_name;
    char host_name[256];
    char host_ip[256];
    int host_port;

    printf("use_host_name (0 for host_ip or 1 for host_name): ");
    scanf("%i", &use_host_name);

    if (use_host_name)
    {
        printf("host_name: ");
        scanf("%s", host_name);
    }
    else
    {
        printf("host_ip: ");
        scanf("%s", host_ip);
    }

    printf("host_port: ");
    scanf("%i", &host_port);

    SOCKADDR_IN sa;
    sa.sin_family = AF_INET;
    sa.sin_port = htons(host_port);
    sa.sin_addr.S_un.S_addr = use_host_name? get_addr(host_name) : inet_addr(host_ip);

    printf("wait for server...\n");

    while (true)
    {
        int connect_res = connect(s, (SOCKADDR *)&sa, sizeof(sa));
        if (!connect_res) break;

        Sleep(250);
    }

    printf("connected\n");
////////////////////////////////////////////////////////////////////////////////

    char *buffer_1 =
    "$GNSS,359772038050465,280113,082505,4503.6879,N,03856.8254,E,0.14,213.30,36.7,09,1.12,A,1*7B\r"
    "$GNSS,359772038050465,280";
    char *buffer_2 = "113,082447,4503.6843,N,03856.8253,E,0.26,213.30,31.2,09,1.12,A,1*71\r";

    if
    (
        send
        (
            s,
            buffer_1, strlen(buffer_1),
            0
        ) == SOCKET_ERROR
    )
    {
        printf("sendto error\n");
    }

    char buffer[256];
    memset(buffer, 0, sizeof(buffer));
    int res = recv
    (
        s,
        buffer, sizeof(buffer),
        0
    );
    if (res == SOCKET_ERROR)
    {
        printf("recv error\n");
    }
    std::string cmd(buffer, res);
    printf("cmd: %s\n", cmd.c_str());

    if
    (
        send
        (
            s,
            buffer_2, strlen(buffer_2),
            0
        ) == SOCKET_ERROR
    )
    {
        printf("sendto error\n");
    }

////////////////////////////////////////////////////////////////////////////////
    /*
    FILE *f = fopen("client_test.data", "rb");
    if (!f)
    {
        printf("can not open data file\n");
        system("pause");
        return -1;
    }

    while (!feof(f))
    {
        char buffer[256];
        memset(buffer, 0, sizeof(buffer));
        fread(buffer, sizeof(buffer), 1, f);

        if
        (
            send
            (
                s,
                buffer, sizeof(buffer),
                0
            ) == SOCKET_ERROR
        )
        {
            printf("sendto error\n");
            break;
        }

    }

    fclose(f);
    */
////////////////////////////////////////////////////////////////////////////////
    closesocket(s);

    WSACleanup();

    system("pause");
    return 0;
}

